3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
39 ok_to_skip_pre_rebase=
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
49 merge_dir="$GIT_DIR"/rebase-merge
50 apply_dir="$GIT_DIR"/rebase-apply
54 test "$(git config --bool rebase.stat)" = true && diffstat=t
58 allow_rerere_autoupdate=
59 # Non-empty if a rebase was in progress when 'git rebase' was invoked
61 # One of {am, merge, interactive}
63 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
65 # One of {'', continue, skip, abort}, as parsed from command line
69 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
72 if test "$type" = merge
74 onto_name=$(cat "$state_dir"/onto_name) &&
75 end=$(cat "$state_dir"/end) &&
76 msgnum=$(cat "$state_dir"/msgnum)
78 head_name=$(cat "$state_dir"/head-name) &&
79 onto=$(cat "$state_dir"/onto) &&
80 orig_head=$(cat "$state_dir"/orig-head) &&
81 GIT_QUIET=$(cat "$state_dir"/quiet)
85 test -d "$merge_dir" || die "$merge_dir directory does not exist"
87 unmerged=$(git ls-files -u)
88 if test -n "$unmerged"
90 echo "You still have unmerged paths in your index"
91 echo "did you forget to use git add?"
95 cmt=`cat "$merge_dir/current"`
96 if ! git diff-index --quiet --ignore-submodules HEAD --
98 if ! git commit --no-verify -C "$cmt"
100 echo "Commit failed, please do not call \"git commit\""
101 echo "directly, but instead do one of the following: "
104 if test -z "$GIT_QUIET"
106 printf "Committed: %0${prec}d " $msgnum
108 echo "$cmt $(git rev-parse HEAD^0)" >> "$merge_dir/rewritten"
110 if test -z "$GIT_QUIET"
112 printf "Already applied: %0${prec}d " $msgnum
115 test -z "$GIT_QUIET" &&
116 GIT_PAGER='' git log --format=%s -1 "$cmt"
118 # onto the next patch:
119 msgnum=$(($msgnum + 1))
120 echo "$msgnum" >"$merge_dir/msgnum"
124 cmt="$(cat "$merge_dir/cmt.$1")"
125 echo "$cmt" > "$merge_dir/current"
126 hd=$(git rev-parse --verify HEAD)
127 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
128 msgnum=$(cat "$merge_dir/msgnum")
129 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
130 eval GITHEAD_$hd='$onto_name'
131 export GITHEAD_$cmt GITHEAD_$hd
132 if test -n "$GIT_QUIET"
134 GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
136 test -z "$strategy" && strategy=recursive
137 eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
141 unset GITHEAD_$cmt GITHEAD_$hd
145 git rerere $allow_rerere_autoupdate
149 echo "Strategy: $rv $strategy failed, try another" 1>&2
153 die "Unknown exit code ($rv) from command:" \
154 "git-merge-$strategy $cmt^ -- HEAD $cmt"
159 move_to_original_branch () {
162 message="rebase finished: $head_name onto $onto"
163 git update-ref -m "$message" \
164 $head_name $(git rev-parse HEAD) $orig_head &&
165 git symbolic-ref HEAD $head_name ||
166 die "Could not move back to $head_name"
172 move_to_original_branch
173 git notes copy --for-rewrite=rebase < "$merge_dir"/rewritten
174 if test -x "$GIT_DIR"/hooks/post-rewrite &&
175 test -s "$merge_dir"/rewritten; then
176 "$GIT_DIR"/hooks/post-rewrite rebase < "$merge_dir"/rewritten
182 run_interactive_rebase () {
183 if [ "$interactive_rebase" = implied ]; then
187 . git-rebase--interactive
190 run_pre_rebase_hook () {
191 if test -z "$ok_to_skip_pre_rebase" &&
192 test -x "$GIT_DIR/hooks/pre-rebase"
194 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
195 die "The pre-rebase hook refused to rebase."
199 test -f "$apply_dir"/applying &&
200 die 'It looks like git-am is in progress. Cannot rebase.'
202 if test -d "$apply_dir"
205 state_dir="$apply_dir"
206 elif test -d "$merge_dir"
208 if test -f "$merge_dir"/interactive
211 interactive_rebase=explicit
215 state_dir="$merge_dir"
217 test -n "$type" && in_progress=t
224 ok_to_skip_pre_rebase=yes
227 ok_to_skip_pre_rebase=
229 --continue|--skip|--abort)
230 test $total_argc -eq 1 || usage
234 test 2 -le "$#" || usage
239 interactive_rebase=explicit
241 -p|--preserve-merges)
243 test -z "$interactive_rebase" && interactive_rebase=implied
251 -M|-m|--m|--me|--mer|--merg|--merge)
254 -X*|--strategy-option*)
256 1,-X|1,--strategy-option)
258 *,-X|*,--strategy-option)
261 *,--strategy-option=*)
262 newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
264 newopt="$(expr " $1" : ' -X\(.*\)')" ;;
268 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
270 test -z "$strategy" && strategy=recursive
272 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
273 --strateg=*|--strategy=*|\
274 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
277 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
299 git_am_opt="$git_am_opt -q"
304 git_am_opt="$git_am_opt $1"
306 --whitespace=fix|--whitespace=strip)
312 git_am_opt="$git_am_opt $1"
314 --committer-date-is-author-date|--ignore-date)
315 git_am_opt="$git_am_opt $1"
319 git_am_opt="$git_am_opt $1"
324 -f|--f|--fo|--for|--forc|--force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
327 --rerere-autoupdate|--no-rerere-autoupdate)
328 allow_rerere_autoupdate="$1"
339 test $# -gt 2 && usage
343 test -z "$in_progress" && die "No rebase in progress?"
344 test "$type" = interactive && run_interactive_rebase
349 git update-index --ignore-submodules --refresh &&
350 git diff-files --quiet --ignore-submodules || {
351 echo "You must edit all merge conflicts and then"
352 echo "mark them as resolved using git add"
356 if test -d "$merge_dir"
359 while test "$msgnum" -le "$end"
367 git am --resolved --3way --resolvemsg="$resolvemsg" &&
368 move_to_original_branch
372 git reset --hard HEAD || exit $?
374 if test -d "$merge_dir"
377 msgnum=$(($msgnum + 1))
378 while test "$msgnum" -le "$end"
386 git am -3 --skip --resolvemsg="$resolvemsg" &&
387 move_to_original_branch
395 git symbolic-ref HEAD $head_name ||
396 die "Could not move back to $head_name"
399 git reset --hard $orig_head
405 # Make sure no rebase is in progress
406 if test -n "$in_progress"
409 It seems that there is already a '"${state_dir##*/}"' directory, and
410 I wonder if you are in the middle of another rebase. If that is the
412 git rebase (--continue | --abort | --skip)
413 If that is not the case, please
414 rm -fr '"$state_dir"'
415 and run me again. I am stopping in case you still have something
419 test $# -eq 0 && test -z "$rebase_root" && usage
421 if test -n "$interactive_rebase"
424 state_dir="$merge_dir"
425 elif test -n "$do_merge"
428 state_dir="$merge_dir"
431 state_dir="$apply_dir"
434 if test -z "$rebase_root"
436 # The upstream head must be given. Make sure it is valid.
439 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
440 die "invalid upstream $upstream_name"
442 upstream_arg="$upstream_name"
444 test -z "$onto" && die "You must specify --onto when using --root"
448 upstream_arg="$root_flag"
451 # Make sure the branch to rebase onto is valid.
452 onto_name=${onto-"$upstream_name"}
455 if left=${onto_name%...*} right=${onto_name#*...} &&
456 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
460 die "$onto_name: there are more than one merge bases"
463 die "$onto_name: there is no merge base"
467 die "$onto_name: there is no merge base"
471 onto=$(git rev-parse --verify "${onto_name}^0") ||
472 die "Does not point to a valid commit: $1"
476 # If the branch to rebase is given, that is the branch we will rebase
477 # $branch_name -- branch being rebased, or HEAD (already detached)
478 # $orig_head -- commit object name of tip of the branch before rebasing
479 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
483 # Is it "rebase other $branchname" or "rebase other $commit"?
487 if git show-ref --verify --quiet -- "refs/heads/$1" &&
488 branch=$(git rev-parse -q --verify "refs/heads/$1")
490 head_name="refs/heads/$1"
491 elif branch=$(git rev-parse -q --verify "$1")
493 head_name="detached HEAD"
495 echo >&2 "fatal: no such branch: $1"
500 # Do not need to switch branches, we are already on it.
501 if branch_name=`git symbolic-ref -q HEAD`
503 head_name=$branch_name
504 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
506 head_name="detached HEAD"
507 branch_name=HEAD ;# detached
509 branch=$(git rev-parse --verify "${branch_name}^0") || exit
514 require_clean_work_tree "rebase" "Please commit or stash them."
516 # Now we are rebasing commits $upstream..$branch (or with --root,
517 # everything leading up to $branch) on top of $onto
519 # Check if we are already based on $onto with linear history,
520 # but this should be done only when upstream and onto are the same
521 # and if this is not an interactive rebase.
522 mb=$(git merge-base "$onto" "$branch")
523 if test "$type" != interactive && test "$upstream" = "$onto" &&
524 test "$mb" = "$onto" &&
526 ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
528 if test -z "$force_rebase"
530 # Lazily switch to the target branch if needed...
531 test -z "$switch_to" || git checkout "$switch_to" --
532 say "Current branch $branch_name is up to date."
535 say "Current branch $branch_name is up to date, rebase forced."
539 # If a hook exists, give it a chance to interrupt
540 run_pre_rebase_hook "$upstream_arg" "$@"
542 if test -n "$diffstat"
544 if test -n "$verbose"
546 echo "Changes from $mb to $onto:"
548 # We want color (if set), but no pager
549 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
552 test "$type" = interactive && run_interactive_rebase
554 # Detach HEAD and reset the tree
555 say "First, rewinding head to replay your work on top of it..."
556 git checkout -q "$onto^0" || die "could not detach HEAD"
557 git update-ref ORIG_HEAD $branch
559 # If the $onto is a proper descendant of the tip of the branch, then
560 # we just fast-forwarded.
561 if test "$mb" = "$branch"
563 say "Fast-forwarded $branch_name to $onto_name."
564 move_to_original_branch
568 if test -n "$rebase_root"
570 revisions="$onto..$orig_head"
572 revisions="$upstream..$orig_head"
575 if test -z "$do_merge"
577 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
578 --src-prefix=a/ --dst-prefix=b/ \
579 --no-renames $root_flag "$revisions" |
580 git am $git_am_opt --rebasing --resolvemsg="$resolvemsg" &&
581 move_to_original_branch
583 test 0 != $ret -a -d "$apply_dir" &&
584 echo $head_name > "$apply_dir/head-name" &&
585 echo $onto > "$apply_dir/onto" &&
586 echo $orig_head > "$apply_dir/orig-head" &&
587 echo "$GIT_QUIET" > "$apply_dir/quiet"
591 # start doing a rebase with git-merge
592 # this is rename-aware if the recursive (default) strategy is used
594 mkdir -p "$merge_dir"
595 echo "$onto_name" > "$merge_dir/onto_name"
596 echo "$head_name" > "$merge_dir/head-name"
597 echo "$onto" > "$merge_dir/onto"
598 echo "$orig_head" > "$merge_dir/orig-head"
599 echo "$GIT_QUIET" > "$merge_dir/quiet"
602 for cmt in `git rev-list --reverse --no-merges "$revisions"`
604 msgnum=$(($msgnum + 1))
605 echo "$cmt" > "$merge_dir/cmt.$msgnum"
608 echo 1 >"$merge_dir/msgnum"
609 echo $msgnum >"$merge_dir/end"
614 while test "$msgnum" -le "$end"